Subject: bug#36723: [core-updates] Error building module-import-compiled

From: Marius Bakke <[email-masked]>
Date: Thu, 18 Jul 2019 21:38:29 +0200

Timothy Sample <[email-masked]> writes:

> Hi,
>
> Whenever I try to build the following (i.e., using “guix build -f”)
>
>     (use-modules (guix gexp)
>                  (guix modules))
>
>     (scheme-file
>      "test.scm"
>      (with-imported-modules (source-module-closure
>                              '((gnu build file-systems)))
>        #~(values #t)))
>
> it says:
>
> -----
> building /gnu/store/2gmxyxpfs0a2j6pcn9xagam6hczlvihb-module-import-compiled.drv...
> [ 1/14] Loading './gnu/build/file-systems.scm'...
> [ 2/14] Loading './gnu/system/file-systems.scm'...
> [ 3/14] Loading './gnu/system/uuid.scm'...
> [ 4/14] Loading './guix/build/bournish.scm'...
> [ 5/14] Loading './guix/build/syscalls.scm'...
> Backtrace:
>           11 (primitive-load "/gnu/store/qz6d59zqvdd5pj9hprk7sfjkpy3?")
> In ice-9/eval.scm:
>     619:8 10 (_ #f)
> In srfi/srfi-1.scm:
>    466:18  9 (fold #<procedure 7ffff5d2d520 at ice-9/eval.scm:336:1?> ?)
>    466:18  8 (fold #<procedure 7ffff54bc2c0 at ice-9/eval.scm:336:1?> ?)
>    466:18  7 (fold #<procedure 7ffff54c3dc0 at ice-9/eval.scm:336:1?> ?)
> In ice-9/eval.scm:
>     619:8  6 (_ #(#(#<directory (guix build utils) 7ffff6f53500>) # ?))
> In ice-9/boot-9.scm:
>    2312:4  5 (save-module-excursion _)
> In unknown file:
>            4 (primitive-load "./guix/build/syscalls.scm")
> In ice-9/eval.scm:
>     619:8  3 (_ #f)
> In ice-9/boot-9.scm:
>   2071:24  2 (call-with-deferred-observers #<procedure 7ffff50e4700 ?>)
>    260:13  1 (for-each #<procedure 7ffff50e4480 at ice-9/boot-9.scm?> ?)
> In unknown file:
>            0 (scm-error misc-error #f "~A ~S" ("re-exporting loc?" ?) ?)
>
> ERROR: In procedure scm-error:
> re-exporting local variable: AT_SYMLINK_NOFOLLOW
> builder for `/gnu/store/2gmxyxpfs0a2j6pcn9xagam6hczlvihb-module-import-compiled.drv' failed with exit code 1
> -----
>
> Importing “(guix build syscalls)” by itself using
> “with-imported-modules” works fine.
>
> This is needed when building the Shepherd service for mounting file
> systems, so it prevents me from building any systems on core-updates
> (for example, building a VM or reconfiguring).  I did try (just to be
> sure) running “make clean-go” and then recompiling, but it didn’t help.

Reverting 456c7ade095cce96f47389c37a4fe3b0390047fd makes the problem
disappear.

I don't really understand why, though.